#include <UTFT.h>
#include <UTouch.h>
#include <BaseComp.h>
#include <BaseTemps.h>

int total = 0;
boolean cmpt = false;

Editeur leTotal(230, 20, 60, 24, "0", 0, 'D', true); // fenêtre d'écriture du total de comptage
Bouton comptage(20, 20, 180, 24, "Lancer le comptage", Horloge, false); // bouton d'activation/désactivation du comptage
Bouton razCmpt(20, 60, 180, 24, "RaZ Compteur", Drapeau, true); // bouton de remise à zéro du compteur
CompTemps nouvValeur(1000, true, 0); // séquenceur à une période de une seconde
Label initCmpt(20, 103, "Initialisation du compteur", VGA_BLUE);
Editeur valInit(230, 95, 60, 24, "0", 2, 'D', false); // Editeur de texte qui, à sa fermeture, place sa valeur d'initialisation dans "comptage"

void appuiSurComptage(boolean ap) {
  if (ap) {
    comptage.titre = "Arreter le comptage";
    cmpt = true;
  }
  else {
    comptage.titre = "Lancer le comptage";
    cmpt = false;
  }
  comptage.affiche(); // effectue le changement de titre dans le bouton
}

void appuiSurRaZ(boolean p) {
  total = 0;
  leTotal.affiche(String(total));
}

void delaiDeComptage(long t) { // méthode qui va incrémenter le compteur
  if (cmpt) {
    total++;
    leTotal.affiche(String(total));
  }
}

void quitterValInit(byte p) {
  total = valInit.texte.toInt();
  leTotal.affiche(valInit.texte);
}

void setup() {
  defEcran(LANDSCAPE); // initialisation de l'afficheur en mode paysage
  comptage.surAppui = &appuiSurComptage; // fonction attachée à l'appui sur "comptage"
  razCmpt.surAppui = &appuiSurRaZ; // fonction attachée à l'appui sur RaZ
  nouvValeur.surDelai = &delaiDeComptage; // fonction attachée au "Timer"
  valInit.surQuitter = &quitterValInit; // fonction attachée à l'éditeur de valeur d'initialisation
}

void loop() {
  scruteEvent(); // fait tourner la boutique, c'est-à-dire scrute cycliquement si chacun des composants a quelque chose à faire
}
