#ifndef DivComps_h
#define DivComps_h

#include <Arduino.h>
#include <BaseComp.h>
#include <SdFat.h>
#include <CarteSD.h>

extern unsigned int Red_C10[0x64];
extern unsigned int Blue_C10[0x64];
extern unsigned int Fond_C10[0x64];

class Horloge_Prog : public CompBase{
private:
	int centre_X;
	int centre_Y;
	int rayon_I;
	int rayon_E;
	int rayon;
	byte nbDep;
	byte nbStop;
	boolean marche;
	byte cran[96];
	char strProg[96];
	void traceProg(); 
	void effaceProg();
	CarteSD maSD;
	void ecritStringSD(String s);
	String litStringSD();
	void enrgProgCour();
protected:
public:
	Horloge_Prog() {};
	Horloge_Prog(int, int, int, int, byte = 0);
	~Horloge_Prog() {};
	virtual void affiche();
	void razProg();
	virtual boolean select(int, int);
};

class Bassin : public CompBase{
private:
  InfoDH edtDH;
	int cFond;
	int8_t vague[256];
	int niveau;
	int nivPrec;
	int niveauPb;
	float tempEau;
	float tempEauPrec;
	float kAff = 0.43f;
	byte j = 0;
public:
	Bassin(int, int, int);
	virtual void affiche();
  virtual boolean select(int, int);
	int clNiveau;
	void majNiveau(int);
	void majTempEau(float);
};

#endif