#include <UTM-LatLon.h>

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  Serial.setTimeout(200);
  Serial.println("Là, c'est mon bureau");
  LatLonVersUTM(46.320169758, -0.95013663);
  Serial.print("Zone : "); Serial.println(utm_Z);
  Serial.print("Easting : "); Serial.println(utm_E);
  Serial.print("Northing : "); Serial.println(utm_N);
  utmVersLatLon(utm_E, utm_N, utm_Z);
  Serial.print("Latitude : "); Serial.println(lat, 6);
  Serial.print("Longitude : "); Serial.println(lon, 6);
  Serial.print("Latitude : "); Serial.println(dDecToDMS(lat, 2, false));
  Serial.print("Longitude (signée) : "); Serial.println(dDecToDMS(lon, 3, true));
  Serial.print("Longitude (absolue) : "); Serial.println(dDecToDMS(lon, 3, false));
}

float la, lo;
String Z;
float E, N;

void loop() {
  // put your main code here, to run repeatedly:
  Serial.println();
  Serial.println("Entrez une latitude en degrés décimaux");
  while (! Serial.available()) {}
  la = Serial.parseFloat();
  Serial.println("Entrez une longitude en degrés décimaux");
  while (! Serial.available()) {}
  lo = Serial.parseFloat();
  LatLonVersUTM(la, lo);
  Serial.println("Voici les valeurs correspondances");
  Serial.print("Zone : "); Serial.print(utm_Z);
  Serial.print("  Easting : "); Serial.print(utm_E);
  Serial.print("  Northing : "); Serial.println(utm_N);
  Serial.println();
  Serial.println("Entrez une zone");
  while (! Serial.available()) {}
  Z = Serial.readString();
  Serial.println("Entrez un Northing en mètres");
  while (! Serial.available()) {}
  N = Serial.parseFloat();
  Serial.println("Entrez un Easting en mètres");
  while (! Serial.available()) {}
  E = Serial.parseFloat();
  utmVersLatLon(E, N, Z);
  Serial.println("Voici les valeurs correspondances");
  Serial.print("Latitude : "); Serial.print(lat, 6);
  Serial.print("  Longitude : "); Serial.println(lon, 6);
  Serial.print("Latitude : "); Serial.print(dDecToDMS(lat, 2, false));
  Serial.print("  Longitude : "); Serial.println(dDecToDMS(lon, 3, false));
  Serial.flush();
}
