#include <UTFT.h>
#include <UTouch.h>
#include <BaseComp.h>
#include <BaseTemps.h>

Marque maMarque(20, 20, "Texte item Liste modifiablee", VGA_BLACK);
BoiteListe maBoiteListe(20, 60, 80, "alpha&beta&gamma&delta&epsilon", 'D', true);
Label monChoix(205, 45, "Mon choix", VGA_BLUE);
Editeur leChoix(200, 60, 80, 24, "", 0, 'C', true);
Forme separateur(40, 100, 240, 5, VGA_RED, 'R', 0);
BoutonChoix btn0(40, 120, "Premier choix", VGA_BLACK, 1, 0);
BoutonChoix btn1(40, 140, "Second choix", VGA_BLACK, 1, 1);
BoutonChoix btn2(40, 160, "Bas morceaux", VGA_BLACK, 1, 2);
BoutonChoix btn3(40, 180, "Le reste", VGA_BLACK, 1, 2);
Label monMorceau(205, 150, "Quel morceau", VGA_GREEN);
Editeur leMorceau(190, 165, 120, 24, "", 0, 'C', true);

void AppuiSurMarque (boolean b) {
  maBoiteListe.lectureSeule = ! maMarque.coche;
  maBoiteListe.affiche();
}

void QuitterListe (byte b) {
  leChoix.affiche(maBoiteListe.choix);
}

void choixBtn (byte i, String t) {
  leMorceau.affiche(t);
}

void setup() {
  defEcran(LANDSCAPE); // initialisation de l'afficheur en mode paysage
  maMarque.surAppui = &AppuiSurMarque;
  maBoiteListe.surQuitter = &QuitterListe;
  btn0.surAppui = &choixBtn;
  btn1.surAppui = &choixBtn;
  btn2.surAppui = &choixBtn;
  btn3.surAppui = &choixBtn;
}

void loop() {
  scruteEvent(); // fait tourner la boutique, c'est-à-dire scrute cycliquement si chacun des composants a quelque chose à faire
}
